#include "perso.h"

#ifndef _ENGINE
#define _ENGINE

#define NBGOUTTES 4
#define NBPAILLETTES 100

typedef enum {
	RIEN, GOUTTE, NUAGE1, NUAGE2, NUAGE3, NUAGE4
} Air;

typedef struct {
	Air air[10][7];
	int scrolling, last_scrolling[3];
	char explosion[3][2][10];
	char indice[3];
} Ciel;


void affiche_barre(personnage perso);
Ciel remplissage_ciel(Ciel ciel, personnage perso);
void affiche_ciel(Ciel ciel);
personnage detecte_collision(personnage perso, Ciel* ciel);
Ciel affiche_explosion(Ciel ciel);
void game_over(int position);

#endif