#include "perso.h"
#include "functions.h"

personnage init_perso(personnage perso)
{
	perso.position = 57;
	perso.hauteur = 0;
	perso.fuel = 440;
	perso.sens = LEFT;
	perso.chute = 0;
	
	return perso;
}

personnage move_perso(personnage perso)
{
	perso.direction = NOTHING;

	if((key_down(K_LEFT) || key_down(K_4)) && perso.position >= 0)
	{
		perso.position -= 2;
		perso.sens = LEFT;
	}
	
	if((key_down(K_RIGHT) || key_down(K_6)) && perso.position < 114)
	{
		perso.position += 2;
		perso.sens = RIGHT;
	}
	
	if((key_down(K_UP) || key_down(K_SHIFT) || key_down(K_8)) && perso.fuel > 0)
	{
		perso.fuel -= 2;
		perso.direction = UP;
		
		if(perso.chute < 20)
		{
			perso.chute = 0;
			perso.hauteur++;
		}
		else if(perso.hauteur > 0)
			perso.hauteur -= 3;
	}
	else
	{	
		if(perso.hauteur > 0)
		{
			perso.chute++;
			perso.hauteur -= 3;
			if(perso.hauteur < 0)
				perso.hauteur == 0;
			perso.direction = DOWN;
		}
		else
			perso.direction = NOTHING;
	}
		
	return perso;
}

void affiche_perso(personnage perso)
{
	const unsigned char gus_left[] = {7,192,8,32,112,16,31,240,16,252,21,114,21,30,16,18,15,226,20,82,20,82,20,92,28,112,39,200,37,72,25,48,10,160,30,240,28,112};
	const unsigned char gus_left_negatif[] = {255,255,248,63,240,31,255,255,240,255,245,115,245,31,240,19,255,227,244,83,244,83,244,95,252,127,231,207,229,79,249,63,251,191,255,255,255,255};
	const unsigned char gus_right[] = {7,192,8,32,16,28,31,240,126,16,157,80,241,80,144,16,143,224,148,80,148,80,116,80,28,112,39,200,37,72,25,48,10,160,30,240,28,112};
	const unsigned char gus_right_negatif[] = {255,255,248,63,240,31,255,255,254,31,157,95,241,95,144,31,143,255,148,95,148,95,244,95,252,127,231,207,229,79,249,63,251,191,255,255,255,255};
	const unsigned char jet[] = {31,0,31,0,63,128,63,128,63,128,127,128,127,192,127,192,127,192,255,224,255,224,255,224,255,224,255,224,255,224,255,224,255,224,255,224,255,224};
	
	int hauteur_relative;
	
	if(perso.hauteur < 0)
		perso.hauteur = 0;
		
	hauteur_relative = 36 - (perso.hauteur < 10 ? perso.hauteur : 10);
	
	if(perso.direction == UP)
	{
		ML_bmp_or_cl(jet, perso.position - 2 + (perso.sens == LEFT ? 8 : 0), hauteur_relative + 12, 16, 19);
	}
	
	if(perso.sens == LEFT)
	{
		ML_bmp_or_cl(gus_left, perso.position, hauteur_relative, 16, 19);
		ML_bmp_and_cl(gus_left_negatif, perso.position, hauteur_relative, 16, 19);
	}
	
	if(perso.sens == RIGHT)
	{
		ML_bmp_or_cl(gus_right, perso.position, hauteur_relative, 16, 19);
		ML_bmp_and_cl(gus_right_negatif, perso.position, hauteur_relative, 16, 19);
	}
}